angular.module('avatarModule')
  .component('avatarControls', {
    template: `
      <div class="avatar-controls" >
        <button class="avatar-button randomize" ng-click="$ctrl.randomizeAvatar()">Random!</button>
        <form class="avatar-form">
          <div class="avatar-item" ng-repeat="f in $ctrl.formFields" ng-if="$ctrl.shouldShowField(f.label | camelCase)">
            <label class="avatar-label">{{f.label | addSpacesToTitleCase}}</label>
            <select
              class="avatar-select"
              ng-change="$ctrl.updateAvatar()"
              ng-model="$ctrl.formModel[(f.label | camelCase)]"
            >
              <option
                class="avatar-option"
                ng-repeat="o in f.options"
                value="{{o.value}}"
              >
                {{o.name}}
              </option>
            </select>
          </div>
        </form>
        <button class="avatar-button download" ng-click="$ctrl.downloadSVG()">Download SVG</button>
        <button class="avatar-button download" ng-click="$ctrl.downloadPNG()">Download PNG</button>
        <canvas style="height: 140px; width: 132px; display: none" itemref="canvasRef" id="canvasRef"></canvas>
      </div>
`,
    controller: 'AvatarControlsController',
  });
