/* eslint-disable no-undef */
angular.module('avatarModule').service('AvatarOptions', ['AvatarEnums', 'utilityService',
  function (AvatarEnums, utilityService) {
    const {
      Background,
      BackgroundColor,
      Accessories,
      Clothes,
      ClothesColor,
      Eyebrows,
      Eyes,
      FacialHair,
      FacialHairColor,
      Graphic,
      HairColor,
      HatColor,
      Mouth,
      Skin,
      Top,
    } = AvatarEnums;

    let avatar = {
      accessories: null,
      background: null,
      backgroundColor: null,
      clothes: null,
      clothesColor: null,
      eyes: null,
      eyebrows: null,
      face: null,
      facialHair: null,
      facialHairColor: null,
      graphic: null,
      hairColor: null,
      hatColor: null,
      mouth: null,
      skin: null,
      top: null,
    };

    function getEnumTuple(enumRef) {
      return Object.values(enumRef);
    }

    function randomSelection(enu) {
      const e = getEnumTuple(enu);
      const len = (Object.keys(e).length) - 1;
      const item = (Math.round(Math.random() * len));
      return e[item];
    }

    function get() {
      return utilityService.deepCopy(avatar);
    }

    function setAll(a) {
      avatar = utilityService.deepCopy(a);
    }

    function set(type, value) {
      avatar[type] = value;
    }

    function setRandom() {
      avatar = {
        accessories: randomSelection(Accessories),
        background: randomSelection(Background),
        backgroundColor: randomSelection(BackgroundColor),
        clothes: randomSelection(Clothes),
        clothesColor: randomSelection(ClothesColor),
        eyes: randomSelection(Eyes),
        eyebrows: randomSelection(Eyebrows),
        facialHair: randomSelection(FacialHair),
        facialHairColor: randomSelection(FacialHairColor),
        graphic: randomSelection(Graphic),
        hairColor: randomSelection(HairColor),
        hatColor: randomSelection(HatColor),
        mouth: randomSelection(Mouth),
        skin: randomSelection(Skin),
        top: randomSelection(Top),
      };
    }

    return ({
      get,
      set,
      setAll,
      setRandom,
    });
  }]);
